freeslot(
"S_KIRYU_AIMRIFLE",
"S_KIRYU_FIRE"
)

function A_KiryuShoot(actor)
	if not (actor.target) then
		actor.tics = 3
		return
	end
	
	local missile = P_SpawnPointMissile(actor, actor.target.x+actor.target.momx,
	actor.target.y+actor.target.momy, actor.target.z+actor.target.momz,
	MT_REDRING, actor.x, actor.y, actor.z+(P_MobjFlip(actor)*(actor.height/2)))
	
	if missile and missile.valid
		missile.flags2 = $|MF2_RAILRING|MF2_DONTDRAW
		S_StartSound(actor, sfx_rail1)
		
		for i = 0, 256
			if P_RailThinker(missile)
				break
			else
				P_SpawnMobjFromMobj(missile,0,0,0,MT_SPARK)
			end
		end
	end
end

local aimTime = 93

states[S_KIRYU_AIMRIFLE] = {SPR_PLAY, SPR2_FIRE, 93, nil, 0, 0, S_KIRYU_FIRE}
states[S_KIRYU_FIRE] = {SPR_PLAY, SPR2_FIRE, 10, A_KiryuShoot, 0, 0, S_PLAY_STND}

local function FindEnemyPlayer(actor)
	local dist = 4096*FRACUNIT

	for player in players.iterate do
	
		if (player.spectator)
			continue
		end
		
		if (CBW_Battle.MyTeam(actor,player))
			continue
		end

		if (player.pflags & PF_INVIS)
			continue // ignore notarget
		end

		if not (player.mo)
			continue
		end
		
		if (player.mo == actor) then
			continue
		end

		if (player.mo.health <= 0)
			continue // dead
		end

		if (dist > 0)
		and (P_AproxDistance(P_AproxDistance(player.mo.x - actor.x, player.mo.y - actor.y), player.mo.z - actor.z) > dist)
			continue // Too far away
		end

		if not (P_CheckSight(actor, player.mo))
			continue // out of sight
		end
		
		actor.target = player.mo
		return true
	end
	
	actor.target = actor.player and P_LookForEnemies(actor.player, false, true)
end



local function KiryuGun(player)

	player.panim = PA_DASH
	player.pflags = $1|PF_FULLSTASIS

	if (player.mo.state == S_KIRYU_FIRE) then
		player.mo.frame = B
		return
	end
	
	if not (player.mo.state == S_KIRYU_AIMRIFLE)
		player.mo.state = S_KIRYU_AIMRIFLE
	end
	
	FindEnemyPlayer(player.mo)
	
	if (player.mo.target) then
		
		local targ = P_SpawnMobj(player.mo.target.x, player.mo.target.y, player.mo.target.z, MT_LOCKON)
		if (targ) then
			targ.sprite = SPR_TARG
		end
		
		player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.target.x, player.mo.target.y)
		player.drawangle = player.mo.angle
	end
	
	if (player.mo.tics > aimTime-6) then
		player.mo.frame = B
	else
		player.mo.frame = A
	end
end

local function KiryuBattle(pmo, doaction)

	if not (pmo) then return end
	local player = pmo.player
	
	if (pmo.state == S_KIRYU_AIMRIFLE)
	or (pmo.state == S_KIRYU_FIRE) then
		KiryuGun(player)
	end
	
	if not (P_IsObjectOnGround(pmo)) then
		player.actiontext = nil
		player.actionrings = nil
		return
	end
	
	player.actiontext = "Sniper Rifle"
	player.actionrings = 10
	
	if not (player.actioncooldown)
	and (CBW_Battle.CanDoAction(player))
	and (doaction) then
		KiryuGun(player)
		CBW_Battle.PayRings(player, 10, true)
		CBW_Battle.ApplyCooldown(player, 10*TICRATE)
	end
end
local battleLoaded = false

local function Thinker()
	if not (battleLoaded)
	and (CBW_Battle) then
		local B = CBW_Battle
		battleLoaded = true
		
		local function GarbagePriority4(player)
			if player.mo.state == S_PLAY_GLIDE
				B.SetPriority(player,2,1,nil,2,1,"spin kick")
			elseif player.mo.state == S_PLAY_TWINSPIN
				B.SetPriority(player,1,2,"amy_twinspin",2,3,"axe kick")
			elseif player.mo.state == S_PLAY_FLY
				B.SetPriority(player,1,0,"tails_fly",3,3,"uppercut")
			elseif player.mo.state == S_KIRYU_SLAMDOWN
				B.SetPriority(player,1,0,"fang_tailbounce",3,3,"slam")
			elseif (player.mo.state == S_KIRYU_PUNCH)
			or (player.mo.state == S_KIRYU_PUNCH_MID)
			or (player.mo.state == S_KIRYU_PUNCH_HEAT)
			or (player.mo.state == S_KIRYU_PUNCH_END)
				B.SetPriority(player,1,0,"amy_melee",1,1,"punch")
			end
		end
		
		B.SkinVars["kiryu"] = {
			flags = SKINVARS_GUARD,
			special = KiryuBattle,
			func_priority_ext = GarbagePriority4
		}
		
		if SKINVARS_NOSPINSHIELD
			B.SkinVars["kiryu"].flags = $|SKINVARS_NOSPINSHIELD
		end
	end
end

addHook("ThinkFrame", Thinker)